{%- import "src/_utils.j2" as utils with context -%}
{%- import "src/_tree_utils.j2" as tree with context -%}


{%- set global_ns = namespace(description="data_sharing") -%}
{%- set global_ns.var_stack = [] -%}


{%- macro setDataProcessingRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_processing_root" : uuid }) -%}

  {#- need to initialise -#}
  {%- do globals.global_ns.dataset_vars.update({ "data_processing_names" : [] }) -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_processing_physical_site_titles" : [] }) -%}
{%- endmacro -%}

{%- macro setDataProcessingNames(globals, entity, reply) -%}
  {{ utils.getDatasetNames(entity, globals.global_ns.dataset_vars.name_list, "DataProcessingNames", reply) }}
  {%- set names = utils.global_ns.var_stack.pop() -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_processing_names" : names }) -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_processing_physical_site_titles" : [] }) -%}
{%- endmacro -%}

{%- macro setDataProcessingPhysicalSitesRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_processing_physical_sites_root" : uuid }) -%}

  {#- need to initialise -#}
  {%- do globals.global_ns.dataset_vars.update({ "data_processing_physical_site_titles" : [] }) -%}
{%- endmacro -%}


{%- macro setDataProcessingPhysicalSiteTitles(globals, entity, reply) -%}
  {{ utils.getPhysicalSiteTitles(entity, globals, "DataProcessingPhysicalSiteNames", reply) }}
  {%- set titles = utils.global_ns.var_stack.pop() -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_processing_physical_site_titles" : titles }) -%}
{%- endmacro -%}
 
{%- macro addSiteItemToDataProcessingSharingState(globals, state, site_item) -%}

  {%- set data_processing_closed_sharing_distribution_items = 
  globals.global_ns.dataset_vars.data_processing_closed_sharing_distribution_items -%}
  {%- set data_processing_shared_sharing_distribution_items = 
  globals.global_ns.dataset_vars.data_processing_shared_sharing_distribution_items -%}
   {%- set data_processing_open_sharing_distribution_items = 
  globals.global_ns.dataset_vars.data_processing_open_sharing_distribution_items -%}
  
  {%- if state == "closed" -%}
    {{ utils.addSiteItemToSiteItemList(data_processing_closed_sharing_distribution_items, site_item) }}
  {%- elif state == "shared" -%}
    {{ utils.addSiteItemToSiteItemList(data_processing_shared_sharing_distribution_items, site_item) }}
  {%- elif state == "open" -%}
    {{ utils.addSiteItemToSiteItemList(data_processing_open_sharing_distribution_items, site_item) }}
  {%- endif -%}
{%- endmacro -%}

{%- macro setDataProcessingSharingRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_processing_sharing_root" : uuid }) -%}
{%- endmacro -%}



{%- macro processDataProcessingSharing(globals, state, uuid) -%}

  {#- need to check we are in the right subtree -#}
  {#- however I am not sure we need to go through all depths... ? -#}
  {{ tree.isChildOf(globals, uuid, 
  globals.global_ns.dataset_vars.data_processing_sharing_root) }}
  {%- set answer0 = tree.global_ns.var_stack.pop() -%}

  {{ tree.isChildOf(globals, globals.global_ns.dataset_vars.data_processing_sharing_root,
  globals.global_ns.dataset_vars.data_processing_physical_sites_root) }}
  {%- set answer1 = tree.global_ns.var_stack.pop() -%}

  {{ tree.isChildOf(globals,
  globals.global_ns.dataset_vars.data_processing_physical_sites_root,
  globals.global_ns.dataset_vars.data_processing_root) }}
  {%- set answer2 = tree.global_ns.var_stack.pop() -%}

  {{ "\nuuid " ~ uuid ~ " globals.global_ns.dataset_vars.data_processing_sharing_root "
  ~ globals.global_ns.dataset_vars.data_processing_sharing_root
  ~ " globals.global_ns.dataset_vars.data_processing_physical_sites_root "
  ~ globals.global_ns.dataset_vars.data_processing_physical_sites_root }}
  {{ "\nanswer0 "  ~ answer0 ~ " answer1 "  ~ answer1 ~ " answer2 "  ~ answer2 }}
  {%- if answer0 and answer1 and answer2 -%}

    {%- set data_processing_names = globals.global_ns.dataset_vars.data_processing_names -%}
    {%- set data_processing_physical_site_titles = globals.global_ns.dataset_vars.data_processing_physical_site_titles -%}
    {#- remember: the way data_processing_physical_site_names has been initialised ensures that: -#}
    {#- see utils.getPhysicalSiteTitles  -#}
    {#- - the site elements concerns site names filled in and verified against actual site names -#}
    {#- - or, in the case no site names were given, the site elements are all actual sites -#}
    {#-   taking into account this fact, if no actual sites exist then we are left with the one site: the infrastructure -#}
    {%- for dataset_name in data_processing_names -%}
      {#- if data_processing_physical_site_titles is empty, it means that there was no reply -#}
      {#- for sites, so this means all are concerned -#}
      {%- if data_processing_physical_site_titles|length == 0 -%}
        {{ setDataProcessingPhysicalSiteTitles(globals, none, none) }}
        {%- set data_processing_physical_site_titles = globals.global_ns.dataset_vars.data_processing_physical_site_titles -%}
      {%- endif -%}
      {%- for site_title in data_processing_physical_site_titles -%}
        {{ utils.deepCopy(globals.global_ns.dataset_vars.distribution_site_item) }}
        {%- set item = utils.global_ns.var_stack.pop() -%}
        {%- do item.update({ "dataset_name" : dataset_name }) -%}
        {%- do item.update({ "site_title": site_title })  -%}
        {{ addSiteItemToDataProcessingSharingState(globals, state, item) }}
      {%- endfor -%}
    {%- endfor -%}
  {%- endif -%}

{{ "\ndata_processing_closed_sharing_distribution_items " ~ globals.global_ns.dataset_vars.data_processing_closed_sharing_distribution_items }}
{{ "data_processing_shared_sharing_distribution_items " ~ globals.global_ns.dataset_vars.data_processing_shared_sharing_distribution_items }}
{{ "data_processing_open_sharing_distribution_items " ~ globals.global_ns.dataset_vars.data_processing_open_sharing_distribution_items ~ "\n"}}

{%- endmacro -%}


{%- macro setDataStorageRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_storage_root" : uuid }) -%}

  {#- need to initialise -#}
  {%- do globals.global_ns.dataset_vars.update({ "data_storage_names" : [] }) -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_storage_physical_site_titles" : [] }) -%}
{%- endmacro -%}

{%- macro setDataStoragePhysicalSitesRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_storage_physical_sites_root" : uuid }) -%}

  {#- need to initialise -#}
  {%- do globals.global_ns.dataset_vars.update({ "data_storage_physical_site_titles" : [] }) -%}
{%- endmacro -%}


{%- macro setDataStorageSharingRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_storage_sharing_root" : uuid }) -%}
{%- endmacro -%}


{%- macro setDataStorageNames(globals, entity, reply) -%}
  {{ utils.getDatasetNames(entity, globals.global_ns.dataset_vars.name_list, "DataStorageNames", reply) }}
  {%- set names = utils.global_ns.var_stack.pop() -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_storage_names" : names }) -%}
{%- endmacro -%}

{%- macro setDataStoragePhysicalSiteTitles(globals, entity) -%}
  {{ utils.getPhysicalSiteTitles(entity, globals, "DataStoragePhysicalSiteTitles", none) }}
  {%- set titles = utils.global_ns.var_stack.pop() -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_storage_physical_site_titles" : titles }) -%}
{%- endmacro -%}


{%- macro addSiteItemToDataStorageSharingState(globals, state, site_item) -%}

  {% set data_storage_closed_sharing_distribution_items =
  globals.global_ns.dataset_vars.data_storage_closed_sharing_distribution_items -%}
  {% set data_storage_shared_sharing_distribution_items =
  globals.global_ns.dataset_vars.data_storage_shared_sharing_distribution_items -%}
  {% set data_storage_open_sharing_distribution_items =
  globals.global_ns.dataset_vars.data_storage_open_sharing_distribution_items -%}
  
  {%- if state == "closed" -%}
    {{ utils.addSiteItemToSiteItemList(data_storage_closed_sharing_distribution_items, site_item) }}
  {%- elif state == "shared" -%}
    {{ utils.addSiteItemToSiteItemList(data_storage_shared_sharing_distribution_items, site_item) }} 
  {%- elif state == "open" -%}
    {{ utils.addSiteItemToSiteItemList(data_storage_open_sharing_distribution_items, site_item) }}
  {%- endif -%}
{%- endmacro -%}

{%- macro processDataStorageSharing(globals, state, uuid) -%}
  
  {#- need to check we are in the right subtree -#}
  {#- however I am not sure we need to go through all depths... ? -#}
  {{ tree.isChildOf(globals, uuid, 
  globals.global_ns.dataset_vars.data_storage_sharing_root) }}
  {%- set answer0 = tree.global_ns.var_stack.pop() -%}

  {{ tree.isChildOf(globals, globals.global_ns.dataset_vars.data_storage_sharing_root,
  globals.global_ns.dataset_vars.data_storage_physical_sites_root) }}
  {%- set answer1 = tree.global_ns.var_stack.pop() -%}

  {{ tree.isChildOf(globals,
  globals.global_ns.dataset_vars.data_storage_physical_sites_root,
  globals.global_ns.dataset_vars.data_storage_root) }}
  {%- set answer2 = tree.global_ns.var_stack.pop() -%}

  {%- if answer0 and answer1 and answer2 -%}
    {%- set data_storage_names = globals.global_ns.dataset_vars.data_storage_names -%}
    {%- set data_storage_physical_site_titles = globals.global_ns.dataset_vars.data_storage_physical_site_titles -%}
    {#- remember: the way data_storage_physical_site_titles has been initialised ensures that: -#}
    {#- (see utils.getPhysicalSitesTitles)  -#}
    {#- - in the case no site names were given (as is the case here), the site elements are all actual sites -#}
    {#-   taking into account the fact, if no actual sites exist then we are left with the one site: the infrastructure -#}
    {%- for dataset_name in data_storage_names -%}
      {#- given the previous comment, data_storage_sharing_physical_site_names cannot be empty -#}
      {%- for site_title in data_storage_physical_site_titles -%}
        {{ utils.deepCopy(globals.global_ns.dataset_vars.distribution_site_item) }}
        {%- set item = utils.global_ns.var_stack.pop() -%}
        {%- do item.update({ "dataset_name" : dataset_name }) -%}
        {%- do item.update({ "site_title": site_title })  -%}
        {{ addSiteItemToDataStorageSharingState(globals, state, item) }}
      {%- endfor -%}
    {%- endfor -%}
  {%- endif -%}

  {{ "\ndata_storage_closed_sharing_distribution_items " ~ globals.global_ns.dataset_vars.data_storage_closed_sharing_distribution_items }} 
  {{ "data_storage_shared_sharing_distribution_items " ~ globals.global_ns.dataset_vars.data_storage_shared_sharing_distribution_items }}
  {{ "data_storage_open_sharing_distribution_items " ~ globals.global_ns.dataset_vars.data_storage_open_sharing_distribution_items ~ "\n" }}
{%- endmacro -%}


{%- macro siteItemInSharingLists(closed_list, shared_list, open_list, site_item) -%}
  {#- which to privilege? I guess I'll issue an error message -#}
  
  {{ utils.siteItemExistsInList(closed_list, site_item) }}
  {%- set answer_c = utils.global_ns.var_stack.pop() -%}
  {{ utils.siteItemExistsInList(shared_list, site_item) }}
  {%- set answer_s = utils.global_ns.var_stack.pop() -%}
  {{ utils.siteItemExistsInList(open_list, site_item) }}
  {%- set answer_o = utils.global_ns.var_stack.pop() -%}

  {%- set answer = { "response" : false, "msg" : none } -%}

  {%- if (answer_c and answer_s) or (answer_c and answer_o) or (answer_s and answer_o) -%}
    {%- do answer.update({ "msg" : "conflict" }) -%}
  {%- elif answer_c -%}
    {%- do answer.update({ "response" : true }) -%}
    {%- do answer.update({ "msg" : "closed" }) -%}
  {%- elif answer_s -%}
    {%- do answer.update({ "response" : true }) -%}
    {%- do answer.update({ "msg" : "shared" }) -%}
  {%- elif answer_o -%}
    {%- do answer.update({ "response" : true }) -%}
    {%- do answer.update({ "msg" : "open" }) -%}
  {%- endif -%}

  {%- do global_ns.var_stack.append(answer) -%}
{%- endmacro -%}



{%- macro getSiteItemDataSharingAnswer(globals, site_item) -%}
  {#- DataStorage has precedence over DataProcessing -#}
  {%- set data_storage_closed_sharing_distribution_items = 
  globals.global_ns.dataset_vars.data_storage_closed_sharing_distribution_items -%}
  {%- set data_storage_shared_sharing_distribution_items = 
  globals.global_ns.dataset_vars.data_storage_shared_sharing_distribution_items -%}
  {%- set data_storage_open_sharing_distribution_items = 
  globals.global_ns.dataset_vars.data_storage_open_sharing_distribution_items -%}

  {{ siteItemInSharingLists(
  data_storage_closed_sharing_distribution_items, 
  data_storage_shared_sharing_distribution_items,
  data_storage_open_sharing_distribution_items, site_item) }}
  {%- set answer_storage = global_ns.var_stack.pop()  -%}
  {%- set answer = answer_storage.msg -%}

  {%- if not answer_storage.response -%}
    {%- if answer_storage.msg == "conflict" -%}
      {{ utils.warningMessage(false,
      "in getSiteItemDataSharingAnswer, there is a conflict in Data Storage sharing responses" ) }}
      {%- set answer = "closed" -%}
    {%- elif not answer_storage.msg -%}

      {%- set data_processing_closed_sharing_distribution_items = 
      globals.global_ns.dataset_vars.data_processing_closed_sharing_distribution_items -%}
      {%- set data_processing_shared_sharing_distribution_items = 
      globals.global_ns.dataset_vars.data_processing_shared_sharing_distribution_items -%}
      {%- set data_processing_open_sharing_distribution_items = 
      globals.global_ns.dataset_vars.data_processing_open_sharing_distribution_items -%}

      {{ siteItemInSharingLists(
      data_processing_closed_sharing_distribution_items, 
      data_processing_shared_sharing_distribution_items,
      data_processing_open_sharing_distribution_items, site_item) }}
      {%- set answer_processing = global_ns.var_stack.pop()  -%}
      {%- set answer = answer_processing.msg -%}
      
      {%- if not answer_processing.response -%}
        {%- if answer_processing.msg == "conflict" -%}
          {{ utils.warningMessage(false,
          "in getSiteItemDataSharingAnswer, there is a conflict in Data Processing sharing responses" ) }}
          {%- set answer = "closed" -%}
        {%- elif not answer_processing.msg -%}
          {{ utils.warningMessage(false,
          "in getSiteItemDataSharingAnswer, there is a distribution " ~ site_item ~ " with no data sharing response" ) }}
          {#- choice per default -#}
          {%- set answer = "closed" -%}
        {%- endif -%}
      {%- endif -%}
    {%- endif -%}
  {%- endif -%}

  {%- do global_ns.var_stack.append(answer) -%}
{%- endmacro -%}
